/* gaussjordan4.c                   freeware                   xhunga@tiscali.fr
*/

/* --------------------------------- INCLUDES ------------------------------- */
#include "xa_hfile.h"
/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* Call  :                                                                    */
/* Debug :                                                                    */
/* -------------------------------------------------------------------------- */
void gjA()
{
fraction  a;
fraction  b;
fraction  c;
fraction  d;
fraction  L1;
fraction  L2;
fraction  DetA;
fraction  TraceA;
fraction  amnsL1;
fraction  DetTrpsA;
fraction  TraceTrpsA;

double pbA    [2][2*TWOCOL];matrix mA    ={2,2*TWOCOL,&pbA   [0][0]};
double pTrpsA [2][2*TWOCOL];matrix mTrpsA={2,2*TWOCOL,&pTrpsA[0][0]};
double pbx1   [2][  TWOCOL];matrix mx1   ={2,  TWOCOL,&pbx1  [0][0]};
double pbAx1  [2][  TWOCOL];matrix mAx1  ={2,  TWOCOL,&pbAx1 [0][0]};
double pbL1x1 [2][  TWOCOL];matrix mL1x1 ={2,  TWOCOL,&pbL1x1[0][0]};
/*-------------------------------- PROGRAM ---------------------------------- */
    a =  rndF(9,1); b =  rndF(9,1); c =  rndF(9,1); d =  subF(addF(a,b),c);

   *(mA.pblock+0  *mA.cols+0) = a.numer; *(mA.pblock+0  *mA.cols+1) = a.denom;
   *(mA.pblock+0  *mA.cols+2) = b.numer; *(mA.pblock+0  *mA.cols+3) = b.denom;
   *(mA.pblock+1  *mA.cols+0) = c.numer; *(mA.pblock+1  *mA.cols+1) = c.denom;
   *(mA.pblock+1  *mA.cols+2) = d.numer; *(mA.pblock+1  *mA.cols+3) = d.denom;

                           L1 = subF(a,c);
                           L2 = addF(a,b);
                       amnsL1 = subF(a,L1);
  *(mx1.pblock+0 *mx1.cols+0) =     -b.numer;
  *(mx1.pblock+0 *mx1.cols+1) =      b.denom;
  *(mx1.pblock+1 *mx1.cols+0) = amnsL1.numer;
  *(mx1.pblock+1 *mx1.cols+1) = amnsL1.denom;

  clrscrn();
  printf("\n                                        The vector x :");
  printmI(&mx1);
  printf("\n                              is an eigenvector of A :");
  printmI(&mA);

  printf("\n      corresponding to the eigenvalue L = %.0f since :\n",
  L1.numer);

  printf("\n                                                  Ax :");
   multmF(&mA,&mx1,&mAx1);
  printmI(         &mAx1);
  printf("\n                                              %4.0f x :",
            L1.numer);
  smultmF(L1,&mx1,&mL1x1);
  printmI(        &mL1x1);
  getchar();

  clrscrn();
  TraceA = tracemF(&mA);
    DetA =    detF(&mA);
  printf("\n                 The characteristic equation of A is :\n");
  printf("\n                          L**2 - %4.0f L + %4.0f = 0  \n\n",
               TraceA.numer,     DetA.numer);

           transposemF(&mA,&mTrpsA);
  TraceTrpsA = tracemF(    &mTrpsA);
    DetTrpsA =    detF(    &mTrpsA);
  printf("\n      The characteristic equation of Transpose(A) is :\n");
  printf("\n                          L**2 - %4.0f L + %4.0f = 0  \n\n",
            TraceTrpsA.numer, DetTrpsA.numer);

  printf("\n        A and the Transpose(A) have the same\n");
  printf("\n              characteristic equation         \n");
  printf("\n         also they have the same eigenvalues  \n");
  printf("\n            L1 = %4.0f;   L2 = %4.0f; \n\n",L1.numer,L2.numer);
}

void hello(void)
{
  printf("\n Freeware by : xhunga bernard 06000 Nice France.\n");
  printf("\n\n\n\n\n                                          ");
  printf("\n        A and the Transpose(A) have the same    \n");
  printf("\n              characteristic equation           \n");
  printf("\n                      *******                   \n");
  printf("\n\n\n\n\n\n                                        ");
  printf("\n Distributed  by :  http://www.simtel.net/        ");
  printf("\n                                                  ");
  printf("\n Press return to continue                         ");
  printf("\n                                                  ");

  getchar();
}


/* --------------------------------- MAIN ----------------------------------- */
int main()
{
time_t t;

/*-------------------------------- PROGRAM ---------------------------------- */
  srand(time(&t));
  hello();
do
{


  gjA();


printf("\n Press 'X' Return to stop\n");
} while(toupper(getchar())!='X');

  return 0;
}

