/* gaussjordan4.c                   freeware                   xhunga@tiscali.fr
*/

/* --------------------------------- INCLUDES ------------------------------- */
#include "xa_hfile.h"
/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* Call  :                                                                    */
/* Debug :                                                                    */
/* -------------------------------------------------------------------------- */
void gjA()
{
fraction  a;
fraction  b;
fraction  c;
fraction  d;
fraction  L1;
fraction  L2;
fraction  amnsL1;
fraction  amnsL2;

double pbA     [2][2*TWOCOL];matrix mA     ={2,2*TWOCOL,&pbA     [0][0]};
double pbP     [2][2*TWOCOL];matrix mP     ={2,2*TWOCOL,&pbP     [0][0]};
double pbAP    [2][2*TWOCOL];matrix mAP    ={2,2*TWOCOL,&pbAP    [0][0]};
double pbInvPAP[2][2*TWOCOL];matrix mInvPAP={2,2*TWOCOL,&pbInvPAP[0][0]};
double pbInvP  [2][2*TWOCOL];matrix mInvP  ={2,2*TWOCOL,&pbInvP  [0][0]};
double pbx1    [2][  TWOCOL];matrix mx1    ={2,  TWOCOL,&pbx1    [0][0]};
double pbx2    [2][  TWOCOL];matrix mx2    ={2,  TWOCOL,&pbx2    [0][0]};
double pbAx1   [2][  TWOCOL];matrix mAx1   ={2,  TWOCOL,&pbAx1   [0][0]};
double pbL1x1  [2][  TWOCOL];matrix mL1x1  ={2,  TWOCOL,&pbL1x1  [0][0]};
double pbAx2   [2][  TWOCOL];matrix mAx2   ={2,  TWOCOL,&pbAx2   [0][0]};
double pbL2x2  [2][  TWOCOL];matrix mL2x2  ={2,  TWOCOL,&pbL2x2  [0][0]};
/*-------------------------------- PROGRAM ---------------------------------- */
    a =  rndF(9,1); b =  rndF(9,1); c =  rndF(9,1); d =  subF(addF(a,b),c);

   *(mA.pblock+0  *mA.cols+0) = a.numer; *(mA.pblock+0  *mA.cols+1) = a.denom;
   *(mA.pblock+0  *mA.cols+2) = b.numer; *(mA.pblock+0  *mA.cols+3) = b.denom;
   *(mA.pblock+1  *mA.cols+0) = c.numer; *(mA.pblock+1  *mA.cols+1) = c.denom;
   *(mA.pblock+1  *mA.cols+2) = d.numer; *(mA.pblock+1  *mA.cols+3) = d.denom;

                           L1 = subF(a,c);
                       amnsL1 = subF(a,L1);
  *(mx1.pblock+0 *mx1.cols+0) =     -b.numer;
  *(mx1.pblock+0 *mx1.cols+1) =      b.denom;
  *(mx1.pblock+1 *mx1.cols+0) = amnsL1.numer;
  *(mx1.pblock+1 *mx1.cols+1) = amnsL1.denom;

                           L2 = addF(a,b);
                       amnsL2 = subF(a,L2);
  *(mx2.pblock+0 *mx2.cols+0) =     -b.numer;
  *(mx2.pblock+0 *mx2.cols+1) =      b.denom;
  *(mx2.pblock+1 *mx2.cols+0) = amnsL2.numer;
  *(mx2.pblock+1 *mx2.cols+1) = amnsL2.denom;


  clrscrn();
  printf("\n                                       The vector x1 :");
  printmI(&mx1);
  printf("\n                              is an eigenvector of A :");
  printmI(&mA);

  printf("\n     corresponding to the eigenvalue L1 = %.0f since :\n",
  L1.numer);

  printf("\n                                                  Ax :");
   multmF(&mA,&mx1,&mAx1);
  printmI(         &mAx1);
  printf("\n                                              %4.0f x :",
            L1.numer);
  smultmF(L1,&mx1,&mL1x1);
  printmI(        &mL1x1);
  getchar();

  clrscrn();
  printf("\n                                       The vector x2 :");
  printmI(&mx2);
  printf("\n                              is an eigenvector of A :");
  printmI(&mA);

  printf("\n     corresponding to the eigenvalue L2 = %.0f since :\n",
  L2.numer);

  printf("\n                                                  Ax2 :");
   multmF(&mA,&mx2,&mAx2);
  printmI(         &mAx2);
  printf("\n                                              %4.0f x2 :",
            L2.numer);
  smultmF(L2,&mx2,&mL2x2);
  printmI(        &mL2x2);
  getchar();


  clrscrn();
  printf("\n                                   The eigenvectors x1 :");
  printmI(&mx1);
  printf("\n                                   The eigenvectors x2 :");
  printmI(&mx2);
  printf("\n                      Copy the two eigenvectors into P :");
  copycolF(&mx1,0,&mP,0);
  copycolF(&mx2,0,&mP,1);
  printmI(&mP);
  printf("\n                                          Compute InvP :");
  inverseF(&mP,&mInvP);
   printmF(    &mInvP);
  printf("\n             Compute InvPAP which is a diagonal matrix :");
  multmF(&mA,&mP,&mAP);
  multmF(&mInvP, &mAP,&mInvPAP);
  printmF(            &mInvPAP);
}

void hello(void)
{
  printf("\n Freeware by : xhunga bernard 06000 Nice France.\n");
  printf("\n\n\n\n\n\n                                        ");
  printf("\n   Compute InvPAP which is a diagonal matrix    \n");
  printf("\n                      *******                   \n");
  printf("\n\n\n\n\n\n                                        ");
  printf("\n Distributed  by :  http://www.simtel.net/        ");
  printf("\n                                                  ");
  printf("\n Press return to continue                         ");
  printf("\n                                                  ");

  getchar();
}


/* --------------------------------- MAIN ----------------------------------- */
int main()
{
time_t t;

/*-------------------------------- PROGRAM ---------------------------------- */
  srand(time(&t));
  hello();
do
{


  gjA();


printf("\n Press 'X' Return to stop\n");
} while(toupper(getchar())!='X');

  return 0;
}

