/* gaussjordan4.c                   freeware                   xhunga@tiscali.fr
*/

/* --------------------------------- INCLUDES ------------------------------- */
#include "xa_hfile.h"
/* ------------------------------------- FUNCTION --------------------------  */
/* Do    :                                                                    */
/*                                                                            */
/* Call  :                                                                    */
/* Debug :                                                                    */
/* -------------------------------------------------------------------------- */
void gjA()
{
fraction  a;
fraction  b;
fraction  c;
fraction  d;
fraction  L1;
fraction  L2;
fraction  det;
fraction  amnsL1;
fraction  amnsL2;

double pbA       [2][2*TWOCOL];matrix mA        ={2,2*TWOCOL,&pbA       [0][0]};
double pbP       [2][2*TWOCOL];matrix mP        ={2,2*TWOCOL,&pbP       [0][0]};
double pbAP      [2][2*TWOCOL];matrix mAP       ={2,2*TWOCOL,&pbAP      [0][0]};
double pbApn     [2][2*TWOCOL];matrix mApn      ={2,2*TWOCOL,&pbApn     [0][0]};
double pbD       [2][2*TWOCOL];matrix mD        ={2,2*TWOCOL,&pbD       [0][0]};
double pbDpn     [2][2*TWOCOL];matrix mDpn      ={2,2*TWOCOL,&pbDpn     [0][0]};
double pbDpnP    [2][2*TWOCOL];matrix mDpnP     ={2,2*TWOCOL,&pbDpnP    [0][0]};
double pbInvP    [2][2*TWOCOL];matrix mInvP     ={2,2*TWOCOL,&pbInvP    [0][0]};
double pbx1      [2][  TWOCOL];matrix mx1       ={2,  TWOCOL,&pbx1      [0][0]};
double pbx2      [2][  TWOCOL];matrix mx2       ={2,  TWOCOL,&pbx2      [0][0]};
double pbAx1     [2][  TWOCOL];matrix mAx1      ={2,  TWOCOL,&pbAx1     [0][0]};
double pbL1x1    [2][  TWOCOL];matrix mL1x1     ={2,  TWOCOL,&pbL1x1    [0][0]};
double pbAx2     [2][  TWOCOL];matrix mAx2      ={2,  TWOCOL,&pbAx2     [0][0]};
double pbL2x2    [2][  TWOCOL];matrix mL2x2     ={2,  TWOCOL,&pbL2x2    [0][0]};
double pInvP_DpnP[2][2*TWOCOL];matrix mInvP_DpnP={2,2*TWOCOL,&pInvP_DpnP[0][0]};

/*-------------------------------- PROGRAM ---------------------------------- */
    do
  {
    a =  rndF(9,1); b =  rndF(9,1); c =  rndF(9,1); d =  subF(addF(a,b),c);

   *(mA.pblock+0  *mA.cols+0) = a.numer; *(mA.pblock+0  *mA.cols+1) = a.denom;
   *(mA.pblock+0  *mA.cols+2) = b.numer; *(mA.pblock+0  *mA.cols+3) = b.denom;
   *(mA.pblock+1  *mA.cols+0) = c.numer; *(mA.pblock+1  *mA.cols+1) = c.denom;
   *(mA.pblock+1  *mA.cols+2) = d.numer; *(mA.pblock+1  *mA.cols+3) = d.denom;

    det = detF(&mA);
     printf(".");
  }while(!det.numer);
                           L1 = subF(a,c);
                       amnsL1 = subF(a,L1);
  *(mx1.pblock+0 *mx1.cols+0) =     -b.numer;
  *(mx1.pblock+0 *mx1.cols+1) =      b.denom;
  *(mx1.pblock+1 *mx1.cols+0) = amnsL1.numer;
  *(mx1.pblock+1 *mx1.cols+1) = amnsL1.denom;

                           L2 = addF(a,b);
                       amnsL2 = subF(a,L2);
  *(mx2.pblock+0 *mx2.cols+0) =     -b.numer;
  *(mx2.pblock+0 *mx2.cols+1) =      b.denom;
  *(mx2.pblock+1 *mx2.cols+0) = amnsL2.numer;
  *(mx2.pblock+1 *mx2.cols+1) = amnsL2.denom;


  clrscrn();
  printf("\n                             A a diagonalizable matrix :");
  printmI(&mA);
  copycolF(&mx1,0,&mP,0);
  copycolF(&mx2,0,&mP,1);
  inverseF(&mP,&mInvP);
  printf("\n                                    With the help of P :");
  printmI(&mP);
   multmF(&mA,&mP,&mAP);
  multmF(&mInvP, &mAP,&mD);
  printf("\n                You can compute the diagonal matrix D  :");
  printmI(            &mD);
  getchar();

  clrscrn();
  printf("\n                                                  A**5 :");
  powermF(&mA,5,&mApn);;
  printmI(      &mApn);
  printf("\n                                           P D**5 InvP :");
  powermF(&mD,5,&mDpn);;
   multmF(&mP,&mDpn,&mDpnP);
   multmF(&mDpnP,&mInvP,&mInvP_DpnP);
 printmI(               &mInvP_DpnP);

}

void hello(void)
{
  printf("\n Freeware by : xhunga bernard 06000 Nice France.\n");
  printf("\n\n\n\n\n\n                                        ");
  printf("\n                  A**5 = P D**5 InvP            \n");
  printf("\n                      *******                   \n");
  printf("\n\n\n\n\n\n                                        ");
  printf("\n Distributed  by :  http://www.simtel.net/        ");
  printf("\n                                                  ");
  printf("\n Press return to continue                         ");
  printf("\n                                                  ");

  getchar();
}


/* --------------------------------- MAIN ----------------------------------- */
int main()
{
time_t t;

/*-------------------------------- PROGRAM ---------------------------------- */
  srand(time(&t));
  hello();
do
{


  gjA();


printf("\n Press 'X' Return to stop\n");
} while(toupper(getchar())!='X');

  return 0;
}

